;7-11-19
;    -fix
;     - fix
;      -fix

;22:15 -  - 
;8-11-19     
;+   -    

;08-11-19,9:32   
;12-54  up, ,     - fix

;08-11-19,15:46  

;09-11-19,11-20   ,    -
; 14:04 ,   .
;14-34: fix  ( )
;15:15  
;16:02 ,  
;17:04  :  gameover(+),  
;1.11, 8:35    
;8:52      

; 12-11-2019
;7:36      

;0-empty
;1-wall
;2-key
;3-locked door
;4-treasure
;5-ball

;directions
; 0
;3.1
; 2

	device zxspectrum128
        ORG #6000
begin

pspr	equ $B000; place player sprite(old D800)
rba		equ $AF00 ; shifted ball
rmons	equ $D000 ; sprite monster shifted 0-7

	ld a,$10,bc,$7ffd:out (c),a
;	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir
	ld hl,song:call INIT

;bright grid for debug
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir

	call blacks
	xor a:out ($FE),a

;music
	di
	ld hl,$BD00,de,$BD01,(hl),$BE,bc,256:ldir
	ld a,$BD,i,a
	im 2
	ld hl,intvec,de,$BEBE,bc,intvec_e-intvec:ldir
	ei


prmenu:
;wait key
wk:
	xor a: in a,($FE)
	cpl
	and 31
	jr nz,wk

	ld hl,prm3
	call prm

	ld hl,prm4
	call prm
	ld hl,pr_c
	ld a,(ct):or a:jr z,item1
	ld hl,pr_q
item1:
	call prm

	ld hl,prm5
	call prm

	ld hl,pr_e
	ld a,(lt):or a:jr nz,item2
	ld hl,pr_h
item2:
	call prm

	ld hl,prm6
	call prm

keysc:
;1
	ld a,$f7:in a,($FE):and 1:jp z,k1
;2
	ld a,$f7:in a,($FE):and 2:jp z,k2
;0
	ld a,$EF:in a,($FE):and 1:jp nz,keysc
	jp ex_mnu
k1: ;control
	ld a,(ct):xor 1: ld (ct),a
	jp prmenu
k2: ;game type
	ld a,(lt):xor 1: ld (lt),a
	jp prmenu
ex_mnu:
	ld a,(ct):or a:jp z,no_set_key
;Q
	ld a,$FB,(keyu+1),a
	ld a,1,(keyu+5),a
;A
	ld a,$FD,(keyd+1),a
	ld a,1,(keyd+5),a
;O
	ld a,$DF,(keyl+1),a
	ld a,2,(keyl+5),a
;P
	ld a,$DF,(keyr+1),a
	ld a,1,(keyr+5),a
;M
	ld a,$7F,(keyf+1),a
	ld a,4,(keyf+5),a
no_set_key:

;ball
;	ld a,0,(moveball),a
;	ld hl,$3353,(bx),hl
;	ld hl,$01ff,(dbx),hl
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;menu etc

;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
gs:
; init variables
	call initvars
;
gl:
	call drawmaze

;directions
; 0
;3.1
; 2
;copu,copd,copr,copl
;beginning: prepare player direction
	ld a,(mdir)
	ld bc,dpbt
	call jmpbyN

	call lmap

	ld a,(moveball)
	or a
	call z,draw_new_ball

;************* G A M E  O N *****************
kboard:
;keep previous data
	ld a,(mdir),(pmdir),a
	ld hl,(px),(ppxy),hl

keyl: ld a,$F7:in a,(#FE):and 16;5 is left
	jp nz,keyr
	call left
	jp keyu
keyr: ld a,$EF:in a,(#FE):and 4;8 is right
	jp nz,keyu
	call right
keyu: ld a,$EF:in a,(#FE):and 8;7 is up
	jp nz,keyd
	call up
	jp keyf
keyd: ld a,$EF:in a,(#FE):and 16;6 is down
	jp nz,keyf
	call down
keyf:	ld a,$EF:in a,($FE):and 1:jp nz,ekey
fo:
	call fire
ekey:
;Enter
	ld a,$BF:in a,($FE):and 1:jp z,fo
	
	call moveball
;move monster
	call movemonst

;check collision
	ld a,(moveball)
	or a:jp nz,colmonstest
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
coltest:
;player-ball
	ld hl,(by)
	call div192; L=y
	ld a,c
	ld (badis),a

;ball XY
	ld a,(bx)
	ld (_R2TLX),a
	add a,8
	ld (_R2BRX),a
	ld a,l
	ld (_R2TLY),a
	add a,8
	ld (_R2BRY),a

	ld a,(mdis)
	cp c
	jp nz,colmonstest;if ball rom and playr romm differ,skip test

	ld a,(px)
	ld (_R1TLX),a
	add a,16
	ld (_R1BRX),a

	ld a,(py)
	ld (_R1TLY),a
	add a,16
	ld (_R1BRY),a

	call recti
	jp z,colmonstest ;no ball-player,go monsters
	ld a,$C9,(moveball),a
	ld hl,ballc:inc (hl)
	call erase_old_ball
	call drstat
	jp colmonstest

badis: db 0 ; room where ball

;collision: monster-ball/player
colmonstest:

	ld iy,mtemp
	ld a,(monster_tab_e-monster_tab_b)/(monst1e-monst1b)
colm_lp:
	exa

;skip inactive monster
	bit 3,(iy+1):jp nz,cmnext

;copy data for rect
	ld l,(iy+3)
	ld h,(iy+4)
	call div192;HL/192, L=y coordinate,C=room #
;keep temp values
	ld (iy+10),l ;Y
	ld (iy+9),c ;room
;IY+2 - X coord

;monster
	ld a,(iy+2)
	ld (_R1TLX),a
	add a,16
	ld (_R1BRX),a

	ld a,(iy+10)
	ld (_R1TLY),a
	add a,16
	ld (_R1BRY),a

;monster-player?
	ld a,(mdis)
	cp (iy+9):jp nz,nocolmonsplyr
;	jr $
;player test
	ld a,(px)
	ld (_R2TLX),a
	add a,16
	ld (_R2BRX),a

	ld a,(py)
	ld (_R2TLY),a
	add a,16
	ld (_R2BRY),a

	call recti
	jp z,nocolmonsplyr
;player dead
	ld a,(pmdir)
	ld bc,ept
	call jmpbyN
	ld hl,(px),(ppxy),hl
	ld a,(pmdir)
	ld bc,ept
	call jmpbyN

	ld de,(ppxy)
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
	ex de,hl

;loop draw
	ld b,10
ddlp:
	push bc

	ei:halt:halt
	push de
	ld hl,death
	call drspr2
	pop de
	
	ei:halt:halt
	push de
	ld hl,t_e
	call drspr2
	pop de
	pop bc
	djnz ddlp

	set 3,(iy+1); monster not active
;life--
	ld hl,life:dec (hl)
	jr nz,no_game_over
	ld hl,prm2
	call prm
ws: ld a,$7F:in a,($FE):rra:jr c,ws
	call blacks
	jp prmenu
no_game_over:
	jp gl

nocolmonsplyr:
;no_colplay: ;no collision with player

;monster-ball
	ld a,(moveball);no ball active
	or a:jp nz,cmnext
;where is ball
	ld hl,(by)
	call div192; L=y
	ld a,c
	ld (badis),a
	ld a,(iy+9);ball and monster in room
	cp c
	jp nz,cmnext;if one room check rect

; put ball coordinates
	ld a,(bx)
	ld (_R2TLX),a
	add a,8
	ld (_R2BRX),a
	ld a,l
	ld (_R2TLY),a
	add a,8
	ld (_R2BRY),a

	call recti
	jp z,cmnext

	set 3,(iy+1)
	ld a,$C9,(moveball),a
;life++
	ld hl,life:inc (hl)
	call drstat
	ld a,(mdis),c,a
	ld a,(badis):cp c
	call z,erase_old_ball
	ld a,(mdis)
	cp (iy+9)
	jp nz,noerasemonster
;erase monster
;current Y->previous Y
	ld a,(iy+5),(iy+2),a
;current Y->previous Y
	ld a,(iy+3),(iy+6),a
	ld a,(iy+4),(iy+7),a

	ld a,(iy+0)
	ld bc,emt
	call jmpbyN
noerasemonster:
	jp no_check_col

cmnext:
	ld de,monst1e-monst1b
	add iy,de

	exa
	dec a
	jp nz,colm_lp

no_check_col:
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	ei:halt

	ld a,1::out ($FE),a
;erase ball
	ld a,(moveball)
	or a: call z,erase_old_ball

;erase previous player
	ld a,2:out ($FE),a
	ld a,(pmdir)
	ld bc,ept
	call jmpbyN

	ld a,6:out ($FE),a
;draw player
	ld a,(mdir)
	ld bc,dpt
	call jmpbyN
	ld a,5:out ($FE),a

;draw ball
	ld a,(moveball)
	or a:jp nz,no_draw_new_ball
	call draw_new_ball
no_draw_new_ball:
;draw monsters
	ld a,7:out ($FE),a
	call drawmonster
	ld a,0:out ($FE),a
	jp kboard
;***********************************************************
finale:
	ld hl,prm1
	call prm
;	jr $
fel:
	ei:halt:halt
	ld ix,$5800+7*32+2
	ld b,28-1

f2:
	ld a,(ix+1),(ix+0),a
	inc ix
	djnz f2
	ld a,r
f3:
	inc a
	and 7
	jr z,f3
	ld (ix+0),a
	jp fel

;***********************************************************
lmap:
	ld a,(lt)
	or a:jp nz,hlightd
	
lplace:
	ld de,(px)
	call xy16; X/16,y/16
lpe1:
	call calcatr
lmc=$47;0E ; lightmap color
;	jr $
	ld (ix+0),lmc
	ld (ix+1),lmc
	ld (ix+32),lmc
	ld (ix+33),lmc

	ld (ix+0-2),lmc
	ld (ix+1-2),lmc
	ld (ix+32-2),lmc
	ld (ix+33-2),lmc

	ld (ix+0+2),lmc
	ld (ix+1+2),lmc
	ld (ix+32+2),lmc
	ld (ix+33+2),lmc

	ld a,d:or a:jr z,nolu
	ld (ix+0-64-2),lmc
	ld (ix+1-64-2),lmc
	ld (ix+32-64-2),lmc
	ld (ix+33-64-2),lmc

	ld (ix+0-64),lmc
	ld (ix+1-64),lmc
	ld (ix+32-64),lmc
	ld (ix+33-64),lmc

	ld (ix+0-64+2),lmc
	ld (ix+1-64+2),lmc
	ld (ix+32-64+2),lmc
	ld (ix+33-64+2),lmc

nolu:
	ld a,d:cp 11:jr z,nolh
	ld (ix+0+64-2),lmc
	ld (ix+1+64-2),lmc
	ld (ix+32+64-2),lmc
	ld (ix+33+64-2),lmc

	ld (ix+0+64),lmc
	ld (ix+1+64),lmc
	ld (ix+32+64),lmc
	ld (ix+33+64),lmc

	ld (ix+0+64+2),lmc
	ld (ix+1+64+2),lmc
	ld (ix+32+64+2),lmc
	ld (ix+33+64+2),lmc
nolh:
	call mapxy3
	ld a,(ix+0):and 127:ret nz
	res 7,(ix-1)
	res 7,(ix+0)
	res 7,(ix+1)

	res 7,(ix-1-16)
	res 7,(ix+0-16)
	res 7,(ix+1-16)

	ld a,d:cp 11:jr z,nord
	res 7,(ix-1+16)
	res 7,(ix+0+16)
	res 7,(ix+1+16)
nord:
	ret

hlightd:
	ld de,(px)
	call xy16
drw:
	call mapxy3
	ld a,(ix+0):and 127:ret nz
	call lpe1

	ld bc,(mdir),b,0,hl,modx
	add hl,bc
	ld a,e
	or a:ret z
	cp 15:ret z
	add a,(hl):ld e,a
	inc hl,hl,hl,hl
	ld a,d
	or a:ret z
	cp 11:ret z
	add a,(hl):ld d,a
	jr drw

calcatr:
	push bc,hl
	ld l,d,c,e,h,0,b,h
;Y*64
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	add hl,bc
	ld bc,$5800
	add hl,bc
	push hl
	pop ix
	pop hl,bc
	ret
;***********************************************************
jmpbyN: ;BC =table,A=number(0-3)
	ld h,0,l,a
	add hl,hl
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
;tables for routines
dpbt; draw begin position player
	dw copu,copr,copd,copl
ept: ; erase player
	dw epu,epl,epu,epl
dpt: ;draw player
	dw dpu,dpl,dpu,dpl

;vars
px: db 16;*13
py: db 16

;AABBCCDDEEFFGGHHIIJJKKLLMMNNOOPPQQRRSSTTUU
;000102030405060708091011121314151617181920
mdis: db 0;+20; is T ; displacement

pc:db 0 ; player frame count
keyc: db 0 ; keys count
ballc:db 10 ; ball count

life: db 2-1 ; life count
lt: db 0+1;gametype 0-hard/1-easy

;directions
; 0
;3.1
; 2
mdir: db 2 ; move direction

ppxy:dw 0; previous coordinates
pmdir db 0 ; previous direction

;ball vars
bx: db 0
by: dw 0
dbx:db 0
dby:db 0

; M O V E   M O N S T E R
;monst1b:
;	db 0 ; direction +0
;	db 0 ; type 0-7, 8-inactive +1
;	db 13*16 ; current X +2
;	dw 7*16 ; current Y +3
;	db 0 ; previous X +5
;	dw 0 ; previous Y +6
;	db 0 ;previous direction ;+8
;	db 0 ; room place +9
;	db 0 ; Y in room +10

;monst1e:

;directions
; 0
;3.1
; 2
mmt: ; move monster table
	dw mmu,mmr,mmd,mml
emt: ; erase monster table
	dw emu,emr,emu,emr

dmt: ; draw monster table
	dw dmu,dmr,dmu,dmr

;directions
; 0
;3.1
; 2
modx: db  0,1,0,-1
mody: db -1,0,1, 0

dmu: ; draw monster up/down
	ld a,(iy+10)
	call liney
	ld e,(iy+2)
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
	push hl
	ld l,(iy+1),h,0
	ld de,monsters
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ex de,hl
	pop hl
	call dpu2; HL=screen,DE=sprite
	ret
	ld bc,$1000
dru_lp:
	ld a,h
	cp $58
	ret nc
	ld a,(de):inc de:ld (hl),a:inc l
	ld a,(de):inc de:ld (hl),a:dec l
	call nbhl
	djnz dru_lp

	ret

dmr: ; draw monster left/right

	;ld de,(px)
	ld d,(iy+10)
	ld e,(iy+2);X
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de

	push hl
;calc  data
;48 per sprite,8*48=384 per x&7
;(iy+1)-type,t*48

;*384=$180
	ld a,(iy+2)
	and 7
	ld h,a,l,0
	ld de,hl
	srl d:rr l
	add hl,de
	push hl ; keep address

	ld l,(iy+1)
	ld h,0
	ld de,hl

	add hl,hl ;*2
	add hl,de ;*3
;*16
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl

	pop de
	add hl,de
	ld de,rmons
	add hl,de
	ex de,hl;De=sprite
	pop hl;screen address
	call drl2;HL =screen,De=data
	ret

emu: ; erase monster up/down
	ld a,(iy+10)
	call liney
	ld e,(iy+5) ; previous X
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
;	call tma
	call era_e2 ;HL=screen
	ret
;tma:
;	bit 3,(iy+1)
;	ret z
;	ld hl,0
;	ret
	
emr: ; erase monster left right
;	jr $
	;ld de,(ppxy)
	ld d,(iy+10)
	ld e,(iy+5); previous X +5
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de

	ld a,(iy+5);prev.X;ld a,(ppxy)
	call calcmask

;	call tma
	call erl2;HL=screen,D,E,C=mask
	ret

drawmonster:
	ld iy,mtemp
	ld a,(monster_tab_e-monster_tab_b)/(monst1e-monst1b)
dm_lp:
	push af
;skip inactive monster
	bit 3,(iy+1):jp nz,dmnext
;	and 7:out ($FE),a
;	ld bc,20*2
;zz: dec bc
;	ld a,b:or c:jp nz,zz
;erase monster
	ld l,(iy+6)
	ld h,(iy+7)
	call div192;HL/192, L=y coordinate,C=room #
	ld a,(mdis)
	cp c:jp nz,no_erase_monster
;keep temp values
	ld (iy+10),l
	ld (iy+9),c
	ld a,(iy+0)
	ld bc,emt
	call jmpbyN
no_erase_monster:
;	bit 3,(iy+1):jp nz,dmnext

;draw monster
	ld l,(iy+3)
	ld h,(iy+4)
	call div192;HL/192, L=y coordinate,C=room #
	ld a,(mdis)
	cp c:jp nz,no_draw_monster
;keep temp values
	ld (iy+10),l
	ld (iy+9),c
	ld a,(iy+0)
	ld bc,dmt
	call jmpbyN
no_draw_monster:
dmnext:
	ld de,monst1e-monst1b
	add iy,de
	pop af
	dec a
	jp nz,dm_lp
	ret

movemonst:
	ld iy,mtemp
	ld a,(monster_tab_e-monster_tab_b)/(monst1e-monst1b)
mm_lp:
	push af
	bit 3,(iy+1):jp nz,mmnext ;inactive?
;calc room data for proceed
	ld a,(iy+0),(iy+8),a ;prev room

;store previous X
	ld a,(iy+2),(iy+5),a

;store previous Y
	ld l,(iy+3)
	ld h,(iy+4)
	ld (iy+6),l
	ld (iy+7),h

	call div192;HL/192, L=y coordinate,C=room #

	ld (iy+10),l
	ld (iy+9),c
	ld a,(iy+0)
	ld bc,mmt
	call jmpbyN

mmnext:
	ld de,monst1e-monst1b
	add iy,de
	pop af
	dec a
	jp nz,mm_lp
	ret

checkplace:
	ld d,(iy+10)
	ld e,(iy+2)
	ld a,e ; check if on grid
	add a,a
	add a,a
	add a,a
	add a,a
	ld b,a
	ld a,d
	and 15
	or b
	ret
mmu: ;monster moves up
	call checkplace
	jp z,checku
;move on direction
movedir:
	ld l,(iy+0)
	ld h,0
	ld bc,modx
;	add hl,hl
	add hl,bc
	ld b,(hl) ; B=dx
	inc hl,hl,hl,hl
	ld c,(hl) ; C=dy
;X
	ld a,e
	add a,b
	ld e,a
	ld (iy+2),a
;Y
	ld l,(iy+3)
	ld h,(iy+4)
	ld a,c
	add a,a
	sbc a,a
	ld b,a
	add hl,bc
	ld (iy+3),l
	ld (iy+4),h
	ret
checku:
; 0
;3.1
; 2
;get data
	ld a,(iy+9) ; room #
	call mapxy2
;?right
	ld a,(ix+1)
	and 127:jp nz,ubra1
	ld (iy+0),1
	jp movedir
;up?
ubra1:
	ld a,(ix-16)
	and 127
	jp z,movedir
;left?
ubra2:
	ld a,(ix-1)
	and 127:jp nz,ubra3
	ld (iy+0),3
	jp movedir
;back down
ubra3:
	ld (iy+0),2
	jp movedir

mmr:;monster moves right
	call checkplace
	jp nz,movedir

	ld a,(iy+9) ; room #
	call mapxy2
;down?
	ld a,(ix+16)
	and 127:jp nz,rbra1
	ld (iy+0),2
	jp movedir
rbra1:
;?right?
	ld a,(ix+1)
	and 127:jp z,movedir
;?up
	ld a,(ix-16)
	and 127:jp nz,rbra2
	ld (iy+0),0
	jp movedir
rbra2:
	ld (iy+0),3
	jp movedir

mmd:;monster moves down
	call checkplace
	jp nz,movedir

	ld a,(iy+9) ; room #
	call mapxy2
;can go left?
	ld a,(ix-1)
	and 127:jp nz,dbra1
	ld (iy+0),3
	jp movedir
dbra1:
;can go down?
	ld a,(ix+16)
	and 127:jp z,movedir
;can go right?
	ld a,(ix+1)
	and 127:jp nz,dbra2
	ld (iy+0),1
	jp movedir
dbra2:
	ld (iy+0),0
	jp movedir

mml:;monster moves left
	call checkplace
	jp nz,movedir

	ld a,(iy+9) ; room #
	call mapxy2
;can go up?
	ld a,(ix-16)
	and 127:jp nz,lbra1
	ld (iy+0),0
	jp movedir
lbra1:
;can go left?
	ld a,(ix-1)
	and 127:jp z,movedir
;can go down?
	ld a,(ix+16)
	and 127:jp nz,lbra3
	ld (iy+0),2
	jp movedir
lbra3:
;back right
	ld (iy+0),1
	jp movedir

;////////////////erase player sprite//////////////////////
epu:
	ld de,(ppxy)
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de

era_e2:
	ld bc,$1000
erp_lp:
	ld a,h
	cp $58
	ret nc
	ld (hl),c:inc l
	ld (hl),c:dec l
	call nbhl
	djnz erp_lp
	ret

calcmask:
	ld de,$FFFF,c,0
	and 7
	ld b,a
	jr z,noshrma
shma:
	srl d:rr e:rr c
	djnz shma
noshrma:
	ld a,d:cpl:ld d,a
	ld a,e:cpl:ld e,a
	ld a,c:cpl:ld c,a
	ret


epl:
	ld de,(ppxy)
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de

;	ld de,$FFFF,c,0
	ld a,(ppxy)
	call calcmask
;	and 7
;	ld b,a
;	jr z,noshrma
;shma:
;	srl d:rr e:rr c
;	djnz shma
;noshrma:
;	ld a,d:cpl:ld d,a
;	ld a,e:cpl:ld e,a
;	ld a,c:cpl:ld c,a
erl2:
	ld b,16
erl_lp:
;	jr $
	ld a,(hl):and d:ld (hl),a:inc l
	ld a,(hl):and e:ld (hl),a:inc l
	ld a,(hl):and c:ld (hl),a:dec l,l
	call nbhl
	djnz erl_lp
	ret

;draw player sprite
dpu:
	ld de,(px)
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
	ld de,pspr

dpu2:
	ld b,16
drup_lp:
	ld a,h
	cp $58
	ret nc
	ld a,(de):inc de:or (hl):ld (hl),a:inc l
	ld a,(de):inc de:or (hl):ld (hl),a:dec l
	call nbhl
	djnz drup_lp
	ret

dpl:
	ld de,(px)
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
	ld de,pspr

drl2:
	ld b,16
drlp_lp:
	ld a,h
	cp $58
	ret nc
	ld a,(de):inc de:or (hl):ld (hl),a:inc l
	ld a,(de):inc de:or (hl):ld (hl),a:inc l
	ld a,(de):inc de:or (hl):ld (hl),a:dec l,l
	call nbhl
	djnz drlp_lp
	ret
;**************** Player move **********************
left:
	ld de,(px)
	ld a,d
	and 15
	ret nz
	ld a,e
	and 15
	jp nz,gol
	call mapxy
	ld a,(ix-1)
	and 127
	jp z,gol
	cp 1:ret z
	cp 2: jp z,lkey2
	cp 3: jp z,ldoor2
	cp 4: jp z,lgold2
	cp 5: jp z,lball2
	ret

keyplus equ 1

lkey2:
	ld a,(keyc)
	add a,keyplus
	ld (keyc),a
	jp lendball2
ldoor2:
	ld a,(keyc)
	or a
	ret z
	dec a
	ld (keyc),a
	jp lendball2
lgold2:
	call finale
;	ld hl,prm1
;	call prm
;	jr $;not finished yet!
lball2:
	ld a,(ballc)
	add a,3
	ld (ballc),a
lendball2:
	call drstat
lendball:
;erase item
	ld de,(px)
	push de
	ld (ix-1),$0
	ld a,d
	call liney
	call xy16+2
	ld d,0
	add hl,de
	dec hl,hl
;	ld bc,$10aa
	call era_e2;+3
	pop de

gol:
	dec e
	ld a,3,(mdir),a
	ld (px),de
	call lmap
;copy data
copl:
	ld bc,pl
	jp copyd

right:
	ld de,(px)
	ld a,d
	and 15
	ret nz
	ld a,e
	and 15
	jp nz,gor
	call mapxy
	ld a,(ix+1)
	and 127

	jp z,gor
	cp 1:ret z
	cp 2: jp z,rkey2
	cp 3: jp z,rdoor2
	cp 4: jp z,rgold2
	cp 5: jp z,rball2
	ret
rkey2:
	ld a,(keyc)
	add a,keyplus
	ld (keyc),a
	jp rendball2

rdoor2:
	ld a,(keyc)
	or a
	ret z
	dec a
	ld (keyc),a
	jp rendball2
rgold2:
	call finale
;	ld hl,prm1
;	call prm
;	jr $;not finished yet!
rball2:
	ld a,(ballc)
	add a,3
	ld (ballc),a
rendball2:
	call drstat
rendball:
;erase item
	ld de,(px)
	push de
	ld (ix+1),$0
	ld a,d
	call liney
	call xy16+2
	ld d,0
	add hl,de
	inc hl,hl
	call era_e2
	pop de

gor:
	inc e
	ld a,1,(mdir),a
	ld (px),de
	call lmap
;copy data
copr:
	ld bc,pr
copyd:
	ld a,(pc)
	and 2:rra
	ld l,a
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	push hl
	pop iy

	ld de,pspr ; copy data here
	ld a,16
drpr1:
	exa
	ld h,(iy+0):inc iy
	ld l,(iy+0):inc iy
	ld c,0

	ld a,(px)
	and 7
	ld b,a
	jr z,noshr
shr:
	srl h:rr l:rr c
	djnz shr
noshr:
	ld a,h,(de),a:inc de
	ld a,l,(de),a:inc de
	ld a,c,(de),a:inc de
	exa
	dec a
	jp nz,drpr1

;increase frame counter
	call imcpc
	ret

up:
	ld de,(px)
	ld a,e
	and 15
	ret nz
	ld a,d
	and 15
	jp nz,gou
	call mapxy
	ld a,(ix-16)
	and 127
	jp z,gou
	cp 1:ret z
	cp 2: jp z,ukey2
	cp 3: jp z,udoor2
	cp 4: jp z,ugold2
	cp 5: jp z,uball2
	ret
ukey2:
	ld a,(keyc)
	add a,keyplus
	ld (keyc),a
	jp uendball2

udoor2:
	ld a,(keyc)
	or a
	ret z
	dec a
	ld (keyc),a
	jp uendball2
ugold2:
	call finale
;	ld hl,prm1
;	call prm
;	jr $;not finished yet!
uball2:
	ld a,(ballc)
	add a,3
	ld (ballc),a
uendball2:
	call drstat
uendball:
;erase item
	ld de,(px)
	push de
	ld (ix-16),$0
	ld a,d
	call liney
	call xy16+2
	ld d,0
	add hl,de

	ld a,l:sub 64:ld l,a
	sbc a,a
	and $F8
	add a,h:ld h,a

;	ld bc,$10aa
	call era_e2;+3
	pop de


gou:
	dec d
	ld a,d
	cp $FF
	jr nz,contu

;	ld a,(mdis)
	ld hl,mdis:dec (hl)
;	dec a;sub 1;2
;	ld (mdis),a
	ld a,$BF,(py),a
	jp gl

contu:
	ld a,0,(mdir),a
	ld (px),de
	call lmap
;copy to pspr
copu:
	ld bc,pu
copyud:
	ld a,(pc)
	and 2:rra
	ld l,a
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc

	ld de,pspr
	ld bc,32
	ldir
	call imcpc
	ret

down:
	ld de,(px)
	ld a,e
	and 15
	ret nz

	call mapxy
	ld a,(ix+16)
	and 127
	jp z,god
	cp 1:ret z
	cp 2: jp z,dkey2
	cp 3: jp z,ddoor2
	cp 4: jp z,dgold2
	cp 5: jp z,dball2
	ret
dkey2:
	ld a,(keyc)
	add a,keyplus
	ld (keyc),a
	jp dendball2

ddoor2:
	ld a,(keyc)
	or a
	ret z
	dec a
	ld (keyc),a
	jp dendball2
dgold2:
	call finale
;	ld hl,prm1
;	call prm
;	jr $;not finished yet!
dball2:
	ld a,(ballc)
	add a,3
	ld (ballc),a
dendball2:
	call drstat
dendball:
;erase item
	ld de,(px)
	push de
	ld (ix+16),$0
	ld a,d
	call liney
	call xy16+2
	ld d,0
	add hl,de

	ld a,l:add a,64:ld l,a
	sbc a,a
	and 8
	add a,h:ld h,a

;	ld bc,$10aa
	call era_e2;+3
;	jr $
	pop de


god:
	inc d
;check next room
	ld a,d
	and $F0
	cp $C0
	jr nz,noroomd
	ld hl,mdis:inc (hl)
	xor a
	ld (py),a
	jp gl
noroomd:
	ld a,2,(mdir),a
	ld (px),de
	call lmap

copd:
	ld bc,pd
	call copyud
	ret

fire: ;!draw first ball!
;	jr $
	ld a,(moveball)
	or a:ret z
	ld a,(ballc)
	or a:ret z
;detect direction
;	jr $
	ld de,(px)
	ld a,(mdir):or a:jp z,fcase0
	dec a:jp z,fcase1
	dec a:jp z,fcase2
fcase3: ;left
;	jr $
	ld a,e:sub 16:ld e,a
	ld a,d:add a,4:ld d,a
	call mapxy
	and 127:ret nz
	ld a,e,(bx),a

	call mul192
	ld e,d,d,0
	add hl,de
	ld (by),hl

	ld hl,$01FF
endcase3:
	ld (dbx),hl
	xor a:ld (moveball),a

	ld hl,ballc:dec (hl)
;	ld a,(ballc)
;	or a:ret z
;	dec a:ld (ballc),a
	call drstat

	call draw_new_ball
	ret

mul192:
	ld hl,0
	ld bc,192
	ld a,(mdis)
	or a
	ret z
mu192:	add hl,bc
	dec a
	jr nz,mu192
	ret

fcase2: ; look down
	call mapxy
	ld a,(ix+16)
	and 127:ret nz
	ld a,e,(bx),a

	call mul192
	ld e,d,d,0
	add hl,de
	ld bc,16
	add hl,bc
	ld (by),hl

	ld hl,$0101;,(dbx),hl
	jp endcase3
;	xor a:ld (moveball),a
;	call draw_new_ball
;	ret

fcase1: ;right
	ld a,e:add a,16:ld e,a
	ld a,d:add a,4:ld d,a
;	jr $
	call mapxy
	;ld a,(ix+1)
	and 127
	ret nz
	ld a,e,(bx),a

	call mul192
	ld e,d,d,0
	add hl,de
	ld (by),hl

	ld hl,$FF01;,(dbx),hl
	jp endcase3
;	xor a:ld (moveball),a
;	ret

fcase0: ; look up
	ld a,d:sub 16:ret c
	call mapxy
	ld a,(ix-16)
	and 127
	ret nz
	ld a,e,(bx),a

	call mul192
	ld e,d,d,0
	add hl,de
	ld bc,16
	or a:sbc hl,bc
	ld (by),hl

	ld hl,$FF01;,(dbx),hl
	jp endcase3
;	xor a:ld (moveball),a
;	call draw_new_ball
;	ret

tby: dw 0
tbx: db 0
tbdis: db 0

;previous coordinates
pbx:db 0
pby:dw 0

div192:
;HL/192, L=y coordinate,C=room #
;	ld hl,18*192+3
	push de
	ld de,192
	ld c,-1
zu:
	inc c
	or a
	sbc hl,de
	jr nc,zu
	add hl,de ;HL=3,c=18
	pop de
	ret

calcdir:
	push de,bc
	ld b,8
cdlp:
	ld a,(dbx):add a,e::ld e,a
	ld a,(dby):add a,d::ld d,a
	djnz cdlp
	call checkb
	pop bc,de
	ret
checkb:
	ld a,(tbdis)
	call mapxy2
	and 127
	ret

moveball:
	ret ;nop

	ld a,(bx),(pbx),a
	ld hl,(by),(pby),hl

moveb:
;  0      1
; -1,-1  +1,-1 dbx,dby
;
;  2      3
; -1,+1  +1,+1
;	jr $
	ld hl,(by)
	ld a,(dby)
	ld e,a
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld (tby),hl
	
	ld a,(bx),e,a
	ld a,(dbx)
	add a,e
	ld e,a
	ld (tbx),a
	
	call div192
	ld d,l
	ld a,c
	ld (tbdis),a

;check direction

	ld a,(dby)
	cp $FF
	jp z,case01
;case23
	ld a,(dbx)
	cp 1:jp z,case3

;  /
;!/_
case2:
	ld a,2
;	jr $

	call checkb
;!
;!/
;!
	ld a,e:and 15:jp nz,c2t1
;	ld a,(ix-1):and 127:jp nz,chdx
	ld a,(ix-1):and 127:jp z,c2t1
;dead end
	call chdx
	ld a,(ix+16):and 127:call nz,chdy
	jp contmove
c2t1:
; /
;------
	ld a,d:and 15:cp 8:jp nz,c2t2
	ld a,(ix+16):and 127:jp nz,chdy
c2t2:
;    /
;--+
;  !
;  !
;	ld a,e:and 15:cp 8:jr c,c2t3 ;nc
	ld a,d:and 15:cp 8:jr c,c2t3
	bit 3,e:jr nz,c2t3
	ld a,(ix-1):and 127:jp nz,c2t3
	ld a,(ix+15):and 127:jp z,c2t3

	call chdy
	call chdx
c2t3:
	jp contmove

;\
;_\!
case3:
	ld a,3
;	jr $

	call checkb
; !
;\!
; !
	ld a,e:and 15:cp 8:jp nz,c3t1
;	ld a,(ix+1):and 127:jp nz,chdx
	ld a,(ix+1):and 127:jp z,c3t1
;dead end
	call chdx
	ld a,(ix+16):and 127:call nz,chdy
	jp contmove
c3t1:
; \
;------
	ld a,d:and 15:cp 8:jp nz,c3t2
	ld a,(ix+16):and 127:jp nz,chdy
c3t2:
;\
; +--
; !
; !
	ld a,e:and 15:cp 8:jr c,c3t3
	ld a,d:and 15:cp 8:jr c,c3t3
	ld a,(ix+17):and 127:jp nz,chdy
c3t3:
	jp contmove

case01:
	ld a,(dbx)
	cp 1: jp z,case1
;!\
;  \
case0:
	ld a,0
;	jr $

	call checkb
;!
;!\
;!
	ld a,e:and 15:jp nz,c0t1
;	ld a,(ix-1):and 127:jp nz,chdx
	ld a,(ix-1):and 127:jp z,c0t1
;dead end
	call chdx
	ld a,(ix-16):and 127:call nz,chdy
	jp contmove
;	ld a,(ix-17):and 127:jp nz,chdx
c0t1:
;---
; \
	ld a,d:and 15:jp nz,c0t2
	ld a,(ix-16):and 127:jp nz,chdy
c0t2:
;   !
;   !
;---+
;    \
;	ld a,d:and 15:cp 8:jr nc,c0t3
;	ld a,e:and 15:cp 8:jr nc,c0t3
;	ld a,(ix-17):and 127:jp nz,chdx
;c0t3:
	jp contmove

; /!
;/
case1:
	ld a,1
;	jr $

	call checkb
; !
;/!
; !
	ld a,e:and 15:cp 8:jp nz,c1t1
	ld a,(ix+1):and 127:jp nz,chdx
c1t1:
;----
;  /
	ld a,d:and 15:jp nz,c1t2
	ld a,(ix-16):and 127:jp nz,chdy

; !
; +--
;/
	bit 3,e:jr z,c1t3
	ld a,(ix-17):and 127:jp nz,chdy
c1t3:
c1t2:
	jp contmove


chdx:
	ld a,(dbx):neg:ld (dbx),a
	ret
chdy:
	ld a,(dby):neg:ld (dby),a
	ret

contmove:
	ld hl,(tby),(by),hl
	ld a,(tbx),(bx),a
	ret

draw_new_ball:
;ball wisible?
	ld hl,(by)
	call div192
	ld a,(mdis)
	cp c
	ret nz;no need to draw if another room

	ld d,l
	ld a,(bx),e,a
	call xorb
	ret

erase_old_ball:
	ld hl,(pby)
	call div192
	ld a,(mdis)
	cp c
	ret nz
	ld d,l
	ld a,(pbx),e,a
	call xorb
	ret
xorb:
	ld a,d
	ld c,e
	call liney
	call xy16+2
	ld d,0
	add hl,de

	push hl
	ld a,c
	and 7
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,rba
	add hl,de
	ex de,hl
	pop hl
	ld b,8

drb1:
	ld a,h:cp $58:ret nc
	ld a,(de):xor (hl):ld (hl),a:inc de:inc l
	ld a,(de):xor (hl):ld (hl),a:inc de:dec l
	call nbhl
	djnz drb1
	ret

	ld ix,sba
	ld a,8
drb:
	push af
	ld a,h:cp $58:ret nc
	ld d,(ix+0):inc ix
	ld e,0
	ld a,c
	and 7:ld b,a
	jr z,noshb
shb:
	srl d:rr e
	djnz shb
noshb:
	ld a,(hl):xor d:ld (hl),a:inc l
	ld a,(hl):xor e:ld (hl),a:dec l
	call nbhl
	pop af
	dec a
	jp nz,drb

	ret

;in:A=y,out:HL=screen address
liney:
	ld l,a
	and $07
	ld h,a
	ld a,l
	and $c0
	rra
	inc a
	rrca
	rrca
	or h
	ld h,a
	ld a,l
	add a
	add a
	and $e0
	ld l,a
	ret
;draw sprite
drspr:
	push hl
	ld a,d
	call liney
	call xy16+2 ; ;!HARDCODED!
	ld d,0
	add hl,de
	ex de,hl
	ld a,(pc)
	and 2:rra
	ld l,a
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	pop bc
	add hl,bc
;draw sprite
drspr2:
	ld b,16
dsl:
	ld a,d
	cp $58
	jr nc,imcpc
	ld a,(hl),(de),a:inc hl
	inc e
	ld a,(hl),(de),a:inc hl
	dec e
	call nbde
	djnz dsl
imcpc:
	ld a,(pc)
	inc a
	ld (pc),a
	ret

xy16:
	srl e:srl e:srl e:srl e
	srl d:srl d:srl d:srl d
	ret

mapxy3:
	push hl
	push de
	ld a,(mdis)
	jp mapxye
mapxy:
;D.E=y.x,IX=address
	ld a,(mdis)
mapxy2:
	push hl
	push de
	call xy16
mapxye:
	push bc
	ld c,a
	add a,a ;*2
	add a,c ; 3
	add a,a ;*6
	add a,a ;*12

	pop bc

	add a,d
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld d,0
	add hl,de
	ld de,$C000
	add hl,de
	ld a,(hl)
	push hl
	pop ix
	pop de
	pop hl
	ret

blacks:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
;	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir

	ret

;draw
drawmaze:
	call blacks
	exx
	ld hl,$5800
	ld de,32
	exx
	ld de,0
	call mapxy
	ld de,$4000
dyl:
	push de
dxl:
	ld l,(ix+0)
	ld h,0
;	inc ix
	
	res 7,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,tiles
	add hl,bc
	push de
	ld b,16
tl:
	ld a,(hl),(de),a:inc hl
	inc e
	ld a,(hl),(de),a:inc hl
	dec e
	call nbde
	djnz tl
	bit 7,(ix+0)
	jr nz,nomcol

	exx
mc	equ $47
	ld (hl),mc
	add hl,de
	ld (hl),mc:inc hl
	ld (hl),mc
	or a:sbc hl,de
	ld (hl),mc:dec hl
	exx
	
nomcol:

	exx
	inc hl,hl
	exx

	pop de
	inc de
	inc de
	inc ix
	ld a,e
	and 31
	jp nz,dxl
;	jr $
	exx
	add hl,de
	exx

	pop de
	ld a,e
	add a,64
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	cp $58
	jp nz,dyl
;draw data
	ld a,(mdis)
	add a,"A"
	ld l,a,h,0
	ld de,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld b,8
	ld de,$401F-1
ch8:
	ld a,(hl),(de),a:inc hl,d
	djnz ch8
	
	ld a,$46,($581F-1),a
;draw stats - keys,balls
drstat:
;colors for keys
	ld a,5,($581f),a
	ld a,4,($583f),a
	ld ($585f),a
;for balls
	ld a,7,($587f),a
	ld a,6,($589f),a
	ld ($589f+32),a
;life
	ld a,3,($58Df),a
	ld a,$47,($58Df+32),a
	ld ($58Df+64),a

;print values
	ld a,(keyc)
	ld hl,keyt
	ld de,keyt+3
	call prdec

	ld a,(ballc)
	ld hl,balt
	ld de,balt+3
	call prdec

	ld a,(life)
	ld hl,lifet
	ld de,lifet+3
	call prdec

	ret

prdec:
	ld c,-1
pdl:
	inc c
	sub 10
	jr nc,pdl
	add a,10
	push af
	ld a,c
	add a,"0"
	ld (de),a:inc de
	pop af
	add a,"0"
	ld (de),a:inc de
;show text
	ld e,(hl):inc hl
	ld d,(hl):inc hl
st:	ld a,(hl):inc hl
	or a:ret z
	push hl
	ld l,a,h,0
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,8
	push de
pdl8:
	ld a,(hl),(de),a
	inc hl,d
	djnz pdl8
	pop de
	pop hl
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	jr st

keyt:
	dw $401f
	db 129
	db "00"
	db 0
balt:
	dw $401f+3*32
	db 128
	db "00"
	db 0

lifet:
	dw $401f+6*32
	db 130
	db "00"
	db 0

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET

nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

pu:
 incbin "wu0.bin"
 incbin "wu1.bin"
pr:
 incbin "wr0.bin"
 incbin "wr1.bin"
pd:
 incbin "wd0.bin"
 incbin "wd1.bin"
pl:
 incbin "wl0.bin"
 incbin "wl1.bin"

tiles:
t_e: ds 32
t_w: incbin "t_wall4.bin"
t_k: incbin "t_key.bin"
t_d: incbin "t_door.bin"
t_g:incbin "t_gold2.bin"
t_b:incbin "t_ball.bin"
monsters:
	incbin "monster1.bin"
	incbin "monster2.bin"
	incbin "monster3.bin"
	incbin "monster4.bin"
	incbin "monster5.bin"
	incbin "monster6.bin"
	incbin "monster7.bin"
	incbin "monster8.bin"
death: incbin "t_death.bin"
;[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
; 0
;3.1
; 2
monster_tab_b:
monst1b: ;room B -1
	db 2 ; direction
	db 1 ; type 0-7,+8 - inactive
	db 7*16 ;8*16 ; X
	dw 0*16+192*2;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room
monst1e:
;room C
	db 2 ; direction
	db 2 ; type 0-7,+8 - inactive
	db 1*16 ;8*16 ; X
	dw 4*16+192*1;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room D
	db 2 ; direction
	db 3 ; type 0-7,+8 - inactive
	db 1*16 ;8*16 ; X
	dw 10*16+192*3;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room E
	db 2 ; direction
	db 4 ; type 0-7,+8 - inactive
	db 13*16 ;8*16 ; X
	dw 0*16+192*4;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room G
	db 2 ; direction
	db 5 ; type 0-7,+8 - inactive
	db 13*16 ;8*16 ; X
	dw 0*16+192*6;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room H
	db 2 ; direction
	db 6 ; type 0-7,+8 - inactive
	db 9*16 ;8*16 ; X
	dw 0*16+192*7;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room T
	db 2 ; direction
	db 7 ; type 0-7,+8 - inactive
	db 11*16 ;8*16 ; X
	dw 6*16+192*19;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

;room U
	db 2 ; direction
	db 0 ; type 0-7,+8 - inactive
	db 13*16 ;8*16 ; X
	dw 1*16+192*20;1*16 ; Y
	db 0 ; previous X
	dw 0 ; previous Y
	db 0 ;previous direction
	db 0 ; room place
	db 0 ; Y in room

monster_tab_e:
;]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
fnt:incbin "maze.fnt"
sba:incbin "ball.bin"
keychar:
	db %01111100
	db %01000100
	db %01111100
	db %00010000
	db %00110000
	db %00010000
	db %01110000
	db %00000000
manl:
	db %00111100
	db %00111100
	db %00011000
	db %01111110
	db %11011011
	db %00011000
	db %00111100
	db %01100110

intvec:
	push ix,iy
	push af,bc,de,hl
	exx:exa
	push af,bc,de,hl
	call PLAY
	pop hl,de,bc,af
	exx:exa
	pop hl,de,bc,af
	pop iy,ix
	ei:ret
intvec_e:

plyer:include "PTxPlay.a80"
song:incbin "HAP.IS.m.pt3"

;**************************************************************
;example
;check for collisions - monster,player
;player
;	ld a,(px)
;	ld (_R1TLX),a
;	add a,16
;	ld (_R1BRX),a
;
;	ld a,(py)
;	ld (_R1TLY),a
;	add a,16
;	ld (_R1BRY),a

;ball
;	ld a,(bx)
;	ld (_R2TLX),a
;	add a,8
;	ld (_R2BRX),a
;
;	ld a,(by)
;	ld (_R2TLY),a
;	add a,8
;	ld (_R2BRY),a
;	call recti
;	jr z,nocollplyer


recti:
	push hl
	ld a, (_R2BRX)
	ld hl, (_R1TLX - 1)
	cp h
	sbc a, a
	push af
	ld hl, (_R2TLX - 1)
	ld a, (_R1BRX)
	cp h
	sbc a, a
	ld h, a
	pop af
	or h
	push af
	ld a, (_R2BRY)
	ld hl, (_R1TLY - 1)
	cp h
	sbc a, a
	ld h, a
	pop af
	or h
	push af
	ld hl, (_R2TLY - 1)
	ld a, (_R1BRY)
	cp h
	sbc a, a
	ld h, a
	pop af
	or h
	or a
	jp z, __LABEL0
	xor a
	ld (_RE), a
	jp __LABEL1
__LABEL0:
	ld a, 1
	ld (_RE), a
__LABEL1:
	pop hl
	or a
	ret

_R2TLY:	DEFB 00 ; R2.topLeft.y
_R2TLX:	DEFB 00 ; R2.topLeft.x

_R1TLX:	DEFB 00 ; R1.topLeft.x
_R1TLY:	DEFB 00 ; R1.topLeft.y

_RE:	DEFB 00

_R2BRY:	DEFB 00 ; R2.bottomRight.y
_R2BRX:	DEFB 00 ; R2.bottomRight.x

_R1BRX:	DEFB 00 ; R1.bottomRight.x
_R1BRY:	DEFB 00 ; R1.bottomRight.y
;**************************************************************
;menu
ct:db 0

pr_e:
	dw $4820+32*3+8+32+12
	db $44
	db "easy"
	db 255

pr_h:
	dw $4820+32*3+8+32+12
	db $44
	db "hard"
	db 255

pr_c:
	dw $4820+32*2+9+10
	db $46
	db 124,125,126,127,32
	db 255

pr_q:
	dw $4820+32*2+9+10
	db $46
	db "qaopm"
	db 255

prm3:
	dw $4800+8+32
	db $47
	db "Alone in darkmaze"
	db 255
prm4:
	dw $4820+32*2+9
	db $46
	db "1.Control:"
	db 255
prm5:
	dw $4820+32*3+8+32
	db $44
	db "2.Game type:",255
prm6:
	dw $4840+32*4+10+32
	db $45
	db "0.Start game",255


prm1:
	dw $4000+7*32+2
	db $44
	db " Congratulations! You do it ",255

prm2:
	dw $4000+7*32+11
	db 2
	db "Game Over",255

;print text
prm: ;HL=pointer at text
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld a,(hl):inc hl
	ld (mec+1),a
	push de
	exx
	pop de
;convert address to atributes
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
	exx
melp:
	exx
mec: ld (hl),0:inc hl
	exx
	ld a,(hl):inc hl
	ld bc,fnt-256
	push hl
	ld h,0,l,a
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld c,d,b,8
ch8lp:
	ld a,(hl),(de),a
	inc hl,d
	djnz ch8lp
	ld d,c
	pop hl
	inc e
	ld a,(hl)
	cp $FF
	jp nz,melp
	ret

;**************************************************************
initvars:
;zero memory, d-crunch
	ld hl,$BF00
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm
	
	ld hl,pmap,de,$C000:call dzx7_standard

	ld a,$85 ; ball
;room B
	ld ($C000+9*16+9),a
;room B
	ld ($C000+12*16*1+1*16+11),a
;room E
	ld ($C000+192*4+3*16+1),a

	ld a,$82 ; key
;room A
	ld ($C000+1*16+9),a
;room B
	ld ($C000+12*16*1+3*16+1),a
	ld ($C000+12*16*1+1*16+5),a
	ld ($C000+12*16*1+5*16+5),a
;room C
	ld ($C000+12*16*2+1*16+11),a
;room D
	ld ($C000+12*16*3+9*16+1),a
;room E
	ld ($C000+192*4+3*16+11),a
;room F
	ld ($C000+192*5+11*16+7),a
;room G
	ld ($C000+192*6+5*16+11),a
	ld ($C000+192*6+9*16+13),a
;room H -
;room I - 
;room J
	ld ($C000+192*9+1*16+9),a
;room K
	ld ($C000+192*10+1*16+13),a
;room L
	ld ($C000+192*11+7*16+11),a
;room M
	ld ($C000+192*12+9*16+1),a
;room N -

;room O
	ld ($C000+192*14+1*16+11),a
;room P
	ld ($C000+192*15+5*16+5),a
;room Q -

;room R

;room S
	ld ($C000+192*18+1*16+1),a
;room T
	ld ($C000+192*19+5*16+11),a
	ld ($C000+192*19+5*16+13),a
;room U -


	ld a,$83 ;locked door
; room A
	ld ($C000+10*16+5),a
; room B
	ld ($C000+12*16*1+3*16+6),a
	ld ($C000+12*16*1+8*16+13),a
; room C
	ld ($C000+12*16*2+6*16+7),a
; room D
	ld ($C000+12*16*3+11*16+2),a
	ld ($C000+12*16*3+10*16+13),a
; room E

; room F
	ld ($C000+12*16*5+1*16+12),a
	ld ($C000+12*16*5+11*16+12),a
; room G
	ld ($C000+12*16*6+11*16+10),a
; room H
	ld ($C000+12*16*7+6*16+9),a
; room I
; room J
	ld ($C000+12*16*9+7*16+8),a
; room K
	ld ($C000+12*16*10+11*16+12),a
; room L
	ld ($C000+12*16*11+8*16+5),a
; room M
	ld ($C000+12*16*12+8*16+11),a
; room N
	ld ($C000+12*16*13+11*16+12),a
; room O -

; room P
	ld ($C000+12*16*15+7*16+13),a
; room Q -

; room R
	ld ($C000+12*16*17+4*16+11),a
; room S -

; room T
	ld ($C000+12*16*19+7*16+10),a
; room U
	ld ($C000+12*16*20+1*16+12),a

; room U
;treasure - exit
	ld a,$84 ;locked door
	ld ($C000+192*20+11*16+14),a

;copy monster data to work table
	ld hl,monster_tab_b,de,mtemp,bc,monster_tab_e-monster_tab_b:ldir

;shift all monsters
	ld ix,rmons
	ld b,0
sam4:
	ld hl,monsters
;shift one sprite 0-7
	ld a,128; 16*8
sam2:
	push af
	ld d,(hl):inc hl
	ld e,(hl):inc hl
	ld c,0
	ld a,b
	or a:jp z,skipshft
sam1:
	srl d
	rr e
	rr c
	djnz sam1
	ld b,a
skipshft:
	ld (ix+0),d:inc ix
	ld (ix+0),e:inc ix
	ld (ix+0),c:inc ix
	pop af
	dec a
	jp nz,sam2
	inc b
	bit 3,b
	jp z,sam4
;shift ball
;	jr $
	ld ix,rba
	ld b,0
sb3:
	ld hl,sba
	ld c,8
sb1:
	ld d,(hl):inc hl
	ld e,0
	inc b:dec b:jr z,bsh_0
	push bc
sb2:
	srl d:rr e
	djnz sb2
	pop bc
bsh_0:
	ld (ix),d:inc ix
	ld (ix),e:inc ix
	dec c:jr nz,sb1
	inc b
	bit 3,b:jr z,sb3
;game variables
	ld a,16,(px),a,(py),a
	xor a
	ld (mdis),a
	ld (pc),a
	ld (keyc),a
	ld (ballc),a
	ld a,2,(life),a
	ld a,2,(mdir),a
	ld a,$C9,(moveball),a
	ret
;**************************************************************
pmap: incbin "maze.bin.zx7"
zx7:include "zx7.a80"
mtemp: ; temporary fata for monsters
end
	page 0
	org $C000
tit_b:
 incbin "title.code"
tit_e:

	display /d,end-begin
	savesna "!void.sna",begin
	
	savebin "game.code",begin,end-begin
;	display ws

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;title
 di
 ld de,(#5CF4)
 ld hl, #8000
; ld a,#10,bc,#7FFD:out (c),a
 sectors tit_b,tit_e
 call #3d13
 call #8000
;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 jp #6000


 db "what are stare at?"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
	page 0
    SAVETRD "dust.trd","pict.C",tit_b,tit_e-tit_b
    SAVETRD "dust.trd","demo.C",begin,end-begin

;-----------------------------------------------------------
